scServices.statusPages = scOnLoads[scOnLoads.length] = scOnUnloads[scOnUnloads.length] = {
	fSuspendDataKey : null,
	fPages : {},
	fPagesSeen :[],
	fIsReset : false,

	onLoad : function() {
		try{
			if (scServices.scorm12 && scServices.scorm12.isScorm12Active() || scServices.scorm2k4 && scServices.scorm2k4.isScorm2k4Active()) {
				this.fSuspendDataKey = ["pg"];
				this.fSuspendDataVal = scServices.suspendDataStorage.getVal(this.fSuspendDataKey) || "";
				if(this.fSuspendDataVal) this.fPagesSeen = this.fSuspendDataVal.split(",");
				this.fMasteryScore = scServices.suspendDataStorage.getVal(["ms"]) || null;
			}
		} catch(e){scCoLib.util.logError(e);}
	},
	loadSortKey : "5statusPage",
	
	onUnload : function() {
		try{
			if (scServices.scorm12 && scServices.scorm12.isScorm12Active()) {
				this.fWasScorm = true;
				var vApi = scServices.scorm12.getScorm12API();
				scServices.scorm12.checkError(true);
				this.setStatus(vApi);
			} else if(scServices.scorm2k4 && scServices.scorm2k4.isScorm2k4Active()) {
				this.fWasScorm = true;
				var vApi = scServices.scorm2k4.getScorm2k4API();
				this.setStatus(vApi,true);
			}
		} catch(e){scCoLib.util.logError(e);}
	},

	unloadSortKey : "0statusPage",

	initPages : function(pOutArr) {
		var pagesSetup = function(pEntries, pParent) {
			for (var i = 0; i < pEntries.length; i++) {
				var vEntry = pEntries[i];
				if (vEntry.url) {
					var vId = scServices.statusPages.getIdFromUrl(vEntry.url);
					scServices.statusPages.fPages[vId] = {};
					scServices.statusPages.fPages[vId].seen = false;
					if (pParent) scServices.statusPages.fPages[vId].parentId = scServices.statusPages.getIdFromUrl(pParent.url);
				}
				if (vEntry.children) {
					scServices.statusPages.fPages[vId].childrenIds = [];
					for (let j = 0; j < vEntry.children.length; j++) {
						scServices.statusPages.fPages[vId].childrenIds.push(scServices.statusPages.getIdFromUrl(vEntry.children[j].url));						
					}
					pagesSetup(vEntry.children, vEntry);
				}
			}
		}
		pagesSetup(pOutArr);
	},

	setPageSeen : function(pCurrentUrl, pIsOnlyReturn, pIsNotCommit) {
		var vId = this.getIdFromUrl(pCurrentUrl);
		if(this.getTotalPages() !== this.getPagesSeenCount() && this.fPagesSeen.indexOf(vId) === -1 && !pIsOnlyReturn) {
			// si current pas vu
			if (this.fPages[vId] && !this.fPages[vId].seen) {
				// si il a pas d'enfants on l'ajoute
				if (!this.fPages[vId].childrenIds || this.fPages[vId].childrenSeen) this.xAddPagesSeen(pCurrentUrl, pIsNotCommit);
				// s'il a un parent pas vu
				if (this.fPages[vId].parentId) {
					var vParentId = this.fPages[vId].parentId;
					var vParent = this.fPages[vParentId];
					if (!vParent.seen) {
						var vCnt = 0;
						for (var i = 0; i < vParent.childrenIds.length; i++) {
							if (this.fPages[vParent.childrenIds[i]].seen) vCnt++;
						}
						// si les autres enfants de ce parent ont été vu
						if (vParent.childrenIds.length === vCnt) {
							// on relance la fonction sur ce parent en précisant que les enfants sont vu
							this.fPages[vParentId].childrenSeen = true;
							this.setPageSeen(vParentId);
						}
					}
				}
			}
		}
		return this.fPagesSeen;
	},

	getTotalPages : function() {
		return Object.keys(this.fPages).length;
	},

	getPagesSeenCount : function(){
		return this.fPagesSeen.length;
	},

	getPagesSeen : function(){
		return this.fPagesSeen;
	},

	getProgress : function() {
		return Math.round(this.getPagesSeenCount()/this.getTotalPages()*100);
	},

	getIdFromUrl : function(pUrl){
		return pUrl.substring(pUrl.lastIndexOf("/")+1);
	},

	reset : function() {
		this.fPagesSeen = [];
		this.fIsReset = true;
	},

	xAddPagesSeen : function(pUrl, pIsNotCommit) {
		var vKey = this.getIdFromUrl(pUrl), vApi;
		this.fPages[vKey].seen = true;
		this.fPagesSeen.push(vKey);
		if (this.fIsReset) {
			this.fSuspendDataVal = "";
			this.fIsReset = false;
		}
		if(this.fSuspendDataKey) {
			if(this.fSuspendDataVal) this.fSuspendDataVal += ",";
			this.fSuspendDataVal += vKey;
			scServices.suspendDataStorage.setVal(this.fSuspendDataKey, this.fSuspendDataVal);
			if (scServices.scorm12 && scServices.scorm12.isScorm12Active()) {
				vApi = scServices.scorm12.getScorm12API();
				this.setStatus(vApi);
			} else if(scServices.scorm2k4 && scServices.scorm2k4.isScorm2k4Active()) {
				vApi = scServices.scorm2k4.getScorm2k4API();
				this.setStatus(vApi,true);
			}
			if (!pIsNotCommit) scServices.suspendDataStorage.commit();
		}
	},

	setStatus : function(pApi,pIs2k4){
		if(this.getTotalPages() === this.getPagesSeenCount()){
			var vScore = pIs2k4?pApi.GetValue("cmi.core.score.raw"):pApi.LMSGetValue("cmi.core.score.raw");
			if(!this.fIsEval) this.fStatus = "completed";
			else if(!this.fMasteryScore) this.fStatus = vScore!=null?"completed":"incomplete";
			else if(vScore==null) this.fStatus = "incomplete";
			else this.fStatus = vScore < this.fMasteryScore?"failed":"passed";
		} else this.fStatus = "incomplete"
		if(pIs2k4 && (pApi.GetValue("cmi.core.lesson_status") == "incomplete" || pApi.GetValue("cmi.core.lesson_status") == null)) pApi.SetValue("cmi.core.lesson_status", this.fStatus);
		else if (!pIs2k4 && pApi.LMSGetValue && (pApi.LMSGetValue("cmi.core.lesson_status") == "incomplete" || pApi.LMSGetValue("cmi.core.lesson_status") == null)) pApi.LMSSetValue("cmi.core.lesson_status", this.fStatus); 
		if (this.fMasteryScore) scServices.suspendDataStorage.setVal(["ms"], this.fMasteryScore);
	}
}
